<?php
// *******************************************************************
// Title          uddeIM Instant Messages
// Description    Instant Messages System for Mambo 4.5.X/Joomla 1.0.0
// Author         Benjamin Zweifel
// Version        0.5b
// as of          2006/01/03
// Contact        uddeim@yahoo.com
// Copyright       by FMQ
//                This code uses portions of the bbcode script from
//                phpBB (C) 2001 The phpBB Group
// License        This is free software and you may redistribute it under the GPL.
//                uddeIM comes with absolutely no warranty. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                YOU ARE NOT REQUIRED TO KEEP COPYRIGHT NOTICES IN
//                THE HTML OUTPUT OF THIS SCRIPT. YOU ARE NOT ALLOWED
//                TO REMOVE COPYRIGHT NOTICES FROM THE SOURCE CODE.
// *******************************************************************
// This is the bb code parsing script
// *******************************************************************

function bbcode_replace($string) {
	global $config_allowbb;

	if($config_allowbb>0) {
	
		// replace font formatting [b] [i] [u] [color= [size=
	
		// bold
    	$string = preg_replace("/(\[b\])(.*?)(\[\/b\])/si","<span style=\"font-weight: bold\">\\2</span>",$string);

		// underline
    	$string = preg_replace("/(\[u\])(.*?)(\[\/u\])/si","<span style=\"text-decoration: underline\">\\2</span>",$string);

		// italic
		$string = preg_replace("/(\[i\])(.*?)(\[\/i\])/si","<span style=\"font-style: italic\">\\2</span>",$string);

	   // size Max size is 7
	   $string = preg_replace("/\[size=([1-7])\](.+?)\[\/size\]/si","<font size=\\1\">\\2</font>",$string);

	   // color
	   $string = preg_replace("%\[color=(.*?)\](.*?)\[/color\]%si","<span style=\"color: \\1\">\\2</span>",$string);
	

		// more font formatters opened than closed
		do {
			$string.="</span>";
			// close them
		} while (substr_count($string,"<span") > substr_count($string,"</span>"));

		// more font formatters closed than opened (less likely case)	
		do {
			$string="<span>".$string;
			// add a dummy container to balance that out
		} while (substr_count($string,"<span") < substr_count($string,"</span>"));
		
	}
	
	if($config_allowbb > 1) {

		// http, https, ftp, mailto

		$string=str_replace("[url=index.php", "#*#LINKINDEX=#*#", $string);
		$string=str_replace("[url=http://", "#*#LINKHTTP=#*#", $string);
		$string=str_replace("[url=ftp://", "#*#LINKFTP=#*#", $string);
		$string=str_replace("[url=https://", "#*#LINKHTTPS=#*#", $string);
		$string=str_replace("[url=mailto:", "#*#LINKMAILTO=#*#", $string);	

		$string=str_replace("[url]index.php", "#*#LINKINDEX]#*#", $string);		
		$string=str_replace("[url]http://", "#*#LINKHTTP]#*#", $string);
		$string=str_replace("[url]ftp://", "#*#LINKFTP]#*#", $string);
		$string=str_replace("[url]https://", "#*#LINKHTTPS]#*#", $string);
		$string=str_replace("[url]mailto:", "#*#LINKMAILTO]#*#", $string);				
		$string=str_replace("[url]", "[url]http://", $string);
		$string=str_replace("[url=", "[url=http://", $string);
		
		$string=str_replace("#*#LINKHTTP=#*#", "[url=http://", $string);
		$string=str_replace("#*#LINKFTP=#*#", "[url=ftp://", $string);
		$string=str_replace("#*#LINKHTTPS=#*#", "[url=https://", $string);
		$string=str_replace("#*#LINKMAILTO=#*#", "[url=mailto:", $string);			
		$string=str_replace("#*#LINKINDEX=#*#", "[url=index.php", $string);			
					
		$string=str_replace("#*#LINKHTTP]#*#", "[url]http://", $string);
		$string=str_replace("#*#LINKFTP]#*#", "[url]ftp://", $string);
		$string=str_replace("#*#LINKHTTPS]#*#", "[url]https://", $string);
		$string=str_replace("#*#LINKMAILTO]#*#", "[url]mailto:", $string);
		$string=str_replace("#*#LINKINDEX]#*#", "[url]index.php", $string);		

		$string = preg_replace("/\[img size=([0-9][0-9][0-9])\](http\:\/\/.*?)\[\/img\]/si","[#*#img size=$1]$2[/#*#img]",$string);
		$string = preg_replace("/\[img size=([0-9][0-9])\](http\:\/\/.*?)\[\/img\]/si","[#*#img size=$1]$2[/#*#img]",$string);
		$string = preg_replace("/\[img\](http\:\/\/.*?)\[\/img\]/si","[#*#img]$1[/#*#img]",$string);

		$string = preg_replace("/\[img size=([0-9][0-9][0-9])\](.*?)\[\/img\]/si","[img size=$1]http://$2[/img]",$string);
		$string = preg_replace("/\[img size=([0-9][0-9])\](.*?)\[\/img\]/si","[img size=$1]http://$2[/img]",$string);
		$string = preg_replace("/\[img\](.*?)\[\/img\]/si","[img]http://$1[/img]",$string);
		
		$string = str_replace("[#*#img", "[img", $string);
		$string = str_replace("[/#*#img", "[/img", $string);
		

		// ul li replacements
	
		// lists
        $string = preg_replace("/(\[ul\])(.*?)(\[\/ul\])/si","<ul>\\2</ul>",$string);
        $string = preg_replace("/(\[ol\])(.*?)(\[\/ol\])/si","<ol type=1>\\2</ol>",$string);
        $string = preg_replace("/(\[li\])(.*?)(\[\/li\])/si","<li>\\2</li>",$string);
	
		// url replacement

	
		
        // urls
        //make regular HTML URL links targets _blank
        //bbCode URL translation
        $string = preg_replace('/\[url	(.*?)javascript(.*?)\[\/url\]/si','<span style=\'text-decoration: line-through\'>javascript link</span>',$string);
        $string = preg_replace('/\[url=(.*?)javascript(.*?)\](.*?)\[\/url\]/si','<span style=\'text-decoration: line-through\'>javascript link</span>',$string);

		// if comprofiler in link, make link to top instead of blank
		$string = preg_replace("/\[url\](.*?)comprofiler(.*?)\[\/url\]/si","<a href=\\1comprofiler\\2 target=\"_top\">\\1comprofiler\\2</a>",$string);
	    $string = preg_replace("/\[url=(.*?)comprofiler(.*?)\](.*?)\[\/url\]/si","<a href=\"\\1comprofiler\\2\" target=\"_top\">\\3</a>",$string);	

		// now the rest of the links to blank
        $string = preg_replace("/\[url\](.*?)\[\/url\]/si","<a href=\\1 target=\"_blank\">\\1</a>",$string);
        $string = preg_replace("/\[url=(.*?)\](.*?)\[\/url\]/si","<a href=\"\\1\" target=\"_blank\">\\2</a>",$string);	

	
		// img replacement
        // img
        $string = preg_replace("/\[img size=([0-9][0-9][0-9])\](.*?)\[\/img\]/si","<img src=\"$2\" border=\"0\" width=\"$1\" />",$string);
        $string = preg_replace("/\[img size=([0-9][0-9])\](.*?)\[\/img\]/si","<img src=\"$2\" border=\"0\" width=\"$1\" />",$string);
        $string = preg_replace("/\[img\](.*?)\[\/img\]/si","<img src=\"$1\" border=\"0\" />",$string);
        $string = preg_replace("/<img(.*?)javascript(.*?)>/si",'<span style=\'text-decoration: line-through\'>javascript link</span>',$string);	

	}

	return $string;
	
}
	
function smile_replace($string) {	
	global $config_templatedir;
	
	// now replace smilies if that option is turned on 
	// Use Joomlaboard smilies if that is installed, otherwise uddeim's


		$message_emoticons=array(
      ":))"        => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_laughing.gif"  alt="" border="0" align="middle" />',		
	  ":D"         => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_laughing.gif"      alt="" border="0" align="middle"/>',		
      ":*"         => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_heart.gif"      alt="" border="0" align="middle"/>',
      ":?"         => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_wondering.gif"      alt="" border="0" align="middle"/>',
      ":x"         => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_crossed.gif"      alt="" border="0" align="middle"/>',
      "B)"         => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_cool.gif"      alt="" border="0" align="middle"/>',
      ":("         => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_sad.gif"       alt="" border="0" align="middle" />',
      ":)"         => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_smile.gif"     alt="" border="0" align="middle" />',
      ":-("         => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_sad.gif"       alt="" border="0" align="middle" />',
      ":-)"         => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_smile.gif"     alt="" border="0" align="middle" />',
      ":laugh:"    => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_laughing.gif"  alt="" border="0" align="middle" />',
      ":grin:"    => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_laughing.gif"  alt="" border="0" align="middle" />',
      ";)"         => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_wink.gif"      alt="" border="0" align="middle" />',
      ";-)"         => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_wink.gif"      alt="" border="0" align="middle" />',
      ":P"         => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_tongue.gif"    alt="" border="0" align="middle" />',
      ":mad:"      => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_angry.gif"     alt="" border="0" align="middle" />',
      ":angry:"      => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_angry.gif"     alt="" border="0" align="middle" />',
      ":ohmy:"     => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_shocked.gif"   alt="" border="0" align="middle" />',
	   ":o"     => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_shocked.gif"   alt="" border="0" align="middle" />',
      ":shock:"     => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_shocked.gif"   alt="" border="0" align="middle" />',
      ":blush:"    => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_blush.gif"     alt="" border="0" align="middle" />',
      ":kiss:"     => '<img src="components/com_uddeim/templates/'.$config_templatedir.'/images/emoticon_kiss.gif"   alt="" border="0" align="middle" />',
      );

		reset($message_emoticons);
		while (list($emo_txt,$emo_src)=each($message_emoticons)) {
			$string=str_replace($emo_txt,$emo_src,$string);
		}

		return $string;


}

function bbcode_strip($string) {

	// bold
    $string = preg_replace("/(\[b\])(.*?)(\[\/b\])/si","\\2",$string);

	// underline
    $string = preg_replace("/(\[u\])(.*?)(\[\/u\])/si","\\2",$string);

	// italic
	$string = preg_replace("/(\[i\])(.*?)(\[\/i\])/si","\\2",$string);

	// size Max size is 7
	$string = preg_replace("/\[size=([1-7])\](.+?)\[\/size\]/si","\\2",$string);

	// color
	$string = preg_replace("%\[color=(.*?)\](.*?)\[/color\]%si","\\2",$string);
	
	// ul li replacements
	
	// lists
	$string = preg_replace("/(\[ul\])(.*?)(\[\/ul\])/si","\\2",$string);
	$string = preg_replace("/(\[ol\])(.*?)(\[\/ol\])/si","\\2",$string);
	$string = preg_replace("/(\[li\])(.*?)(\[\/li\])/si","\\2\\n",$string);
	
	// url replacement
	$string = preg_replace('/\[url\](.*?)javascript(.*?)\[\/url\]/si','',$string);
	$string = preg_replace('/\[url=(.*?)javascript(.*?)\](.*?)\[\/url\]/si','',$string);
	$string = preg_replace("/\[url\](.*?)\[\/url\]/si","\\1",$string);
	$string = preg_replace("/\[url=(.*?)\](.*?)\[\/url\]/si","\\2 (\\1)",$string);	
	
	// only front tag present
	$string = preg_replace("/\[url=(.*?)\]/si","",$string);	
	
	// img replacement
	// img
	$string = preg_replace("/\[img size=([0-9][0-9][0-9])\](.*?)\[\/img\]/si","",$string);
	$string = preg_replace("/\[img size=([0-9][0-9])\](.*?)\[\/img\]/si","",$string);
	$string = preg_replace("/\[img\](.*?)\[\/img\]/si","",$string);
	$string = preg_replace("/<img(.*?)javascript(.*?)>/si",'',$string);	

	// only front tag present
	$string = preg_replace("/\[img size=([0-9][0-9][0-9])\]]/si","",$string);
	$string = preg_replace("/\[img size=([0-9][0-9])\]]/si","",$string);
	
	// cut remaining single tags
	$string=str_replace("[i]", "", $string);
	$string=str_replace("[/i]", "", $string);
	$string=str_replace("[b]", "", $string);
	$string=str_replace("[/b]", "", $string);
	$string=str_replace("[u]", "", $string);
	$string=str_replace("[/u]", "", $string);
	$string=str_replace("[ul]", "", $string);
	$string=str_replace("[/ul]", "", $string);
	$string=str_replace("[ol]", "", $string);
	$string=str_replace("[/ol]", "", $string);
	$string=str_replace("[li]", "", $string);
	$string=str_replace("[/li]", "", $string);

    $string = preg_replace('/\[url=(.*?)javascript(.*?)\]/si','',$string);	
    $string = preg_replace("/\[img size=([0-9][0-9][0-9])\]/si","",$string);
    $string = preg_replace("/\[img size=([0-9][0-9])\]/si","",$string);
    $string = preg_replace("/\[size=([1-7])\]/si","",$string);
    $string = preg_replace("%\[color=(.*?)\]%si","",$string);
	$string=str_replace("[img]", "", $string);
	$string=str_replace("[/img]", "", $string);
	$string=str_replace("[url]", "", $string);
	$string=str_replace("[/url]", "", $string);		
	$string=str_replace("[/color]", "", $string);
	$string=str_replace("[/size]", "", $string);		
		
		
	return $string;

}
